/*	Copyright (C) 1992 Free Software Foundation, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this software; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef MAPH
#define MAPH
/*  t. lord	Mon Apr  6 18:40:47 1992	*/

#include "rtree.h"

typedef struct xx_sMap *xx_Map;


#ifdef __STDC
typedef void (*xx_MapCopier) (xx_RtreeLeaf outleaf, xx_IntRectangle outrect, void *in);
typedef int (*xx_MapCombinor) (void **out, void *a, void *b);
typedef void (*xx_MapDestructor) (void *a);
struct xx_sMap
{
  xx_Rtree rtree;
  xx_MapCopier copy;
  xx_MapDestructor destroy;
};


extern xx_Map xx_map (xx_MapCopier, xx_MapDestructor);
extern xx_Map xx_map_copy (xx_Map);
extern void xx_free_map (xx_Map);
extern int xx_map_empty (xx_Map);
extern void xx_map_clear (xx_Map);
extern void xx_map_write_rectangle (xx_Map, xx_IntRectangle,
				    xx_MapCombinor, void *);

extern void xx_map_clear_rectangle (xx_Map, xx_IntRectangle);
extern void xx_map_query (xx_Map, xx_IntRectangle, xx_LoopFn, void *);
#else
typedef void (*xx_MapCopier) ();
typedef int (*xx_MapCombinor) ();
typedef void (*xx_MapDestructor) ();
struct xx_sMap
{
  xx_Rtree rtree;
  xx_MapCopier copy;
  xx_MapDestructor destroy;
};


extern xx_Map xx_map ();
extern xx_Map xx_map_copy ();
extern void xx_free_map ();
extern int xx_map_empty ();
extern void xx_map_clear ();
extern void xx_map_write_rectangle ();
extern void xx_map_clear_rectangle ();
extern void xx_map_query ();
#endif

#ifdef PRETTY_PRINT_DECLS
extern void xx_pp_map (ut_PPstate, xx_Map, ut_PPfn leaffn);
#define xx_pp_map_name(M,F) ut_pp_name("xx_Map", M, F)
#endif
#endif

#ifdef PRETTY_PRINT
extern void
xx_pp_map (state, map, leaffn)
     ut_PPstate state;
     xx_Map map;
     ut_PPfn leaffn;
{
  char *indent = ut_indent (state->indentation);

  if (map)
    {
      int r;
      fprintf (state->stream,
	       "%s(xx_Map %x -- copy %x, destroy %x\n",
	       indent, map, map->copy, map->destroy);

      state->indentation += 2;
      xx_pp_rtree (state, map->rtree, leaffn);
      state->indentation -= 2;
      fputs (")\n", state->stream);
    }
  else
    fprintf (state->stream, "%s(xx_Map 0)", indent);
}

#endif
