/*	Copyright (C) 1992 Free Software Foundation, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this software; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


#if !defined(HAVE_UALARM)

#ifdef HAVE_SETITIMER

#include <time.h>

unsigned 
ualarm (first, others)
     unsigned first;
     unsigned others;
{
  struct itimerval foo;

  foo.it_value.tv_sec = first / 1000000;
  foo.it_value.tv_usec = first % 1000000;
  foo.it_interval.tv_sec = others / 1000000;
  foo.it_interval.tv_usec = others % 1000000;
  setitimer (ITIMER_REAL, &foo, (struct itimerval *) 0);
  return 0;
}

#else

unsigned alarm_interval;

unsigned 
ualarm (value, interval)
     unsigned value;
     unsigned interval;
{
  if (value == 0 && interval == 0)
    return alarm (0);
  alarm_interval = interval;
  return alarm (value);
}

#endif
#endif
